//////////////////////////////////
//		TI-BASIC COMPILER		//
//		  Matthew Iselin		//
//////////////////////////////////
// Because I'm sick of using	//
// the calculator's keypad		//
// to write programs...			//
//////////////////////////////////
// These are the tokens which	//
// are written to the output	//
// file.						//
//////////////////////////////////
// Created: 15-5-07				//
// License: GPL					//
// Last Modified: 20-5-07		//
//////////////////////////////////

// PRAGMAS ///////////////////////
#pragma once

// TOKENS ////////////////////////
#define TO_DMS			0x01
#define TO_DEC			0x02
#define TO_FRAC			0x03
#define STORE			0x04
#define BOXPLOT			0x05
#define LEFTSBRACK		0x06
#define RIGHTSBRACK		0x07
#define LEFTBRACE		0x08
#define RIGHTBRACE		0x09
#define RADIANS			0x0A
#define DEGREES			0x0B
#define INVERSE			0x0C
#define SQUARE			0x0D
#define TRANSPOSE		0x0E
#define CUBE			0x0F
#define LEFTBRACKET		0x10
#define RIGHTBRACKET	0x11
#define ROUND			0x12
#define PXLTEST			0x13
#define AUGMENT			0x14
#define ROWSWAP			0x15
#define ROWPLUS			0x16
#define STARROW			0x17
#define STARROWPLUS		0x18
#define MAX				0x19
#define MIN				0x1B
#define MEDIAN			0x1F
#define RANDM			0x20
#define MEAN			0x21
#define SOLVE			0x22
#define SEQFUNC			0x23
#define FNINT			0x24
#define NDERIV			0x25
#define FMIN			0x27
#define FMAX			0x28
#define SPACE			0x29
#define DOUBLEQUOTE		0x2A
#define COMMA			0x2B
#define IMAG_I			0x2C
#define FACTORIAL		0x2D
#define CUBICREG		0x2E
#define QUARTREG		0x2F
#define NUM_0			0x30
#define NUM_1			0x31
#define NUM_2			0x32
#define NUM_3			0x33
#define NUM_4			0x34
#define NUM_5			0x35
#define NUM_6			0x36
#define NUM_7			0x37
#define NUM_8			0x38
#define NUM_9			0x39
#define PERIOD			0x3A
#define EXPONENT		0x3B
#define LOGIC_OR		0x3C
#define LOGIC_XOR		0x3D
#define COLON			0x3E
#define HARD_RETURN		0x3F
#define LOGIC_AND		0x40
#define STR_A			0x41
#define STR_B			0x42
#define STR_C			0x43
#define STR_D			0x44
#define STR_E			0x45
#define STR_F			0x46
#define STR_G			0x47
#define STR_H			0x48
#define STR_I			0x49
#define STR_J			0x4A
#define STR_K			0x4B
#define STR_L			0x4C
#define STR_M			0x4D
#define STR_N			0x4E
#define STR_O			0x4F
#define STR_P			0x50
#define STR_Q			0x51
#define STR_R			0x52
#define STR_S			0x53
#define STR_T			0x54
#define STR_U			0x55
#define STR_V			0x56
#define STR_W			0x57
#define STR_X			0x58
#define STR_Y			0x59
#define STR_Z			0x5A
#define STR_THETA		0x5B
#define PROGRAM			0x5F
/** SysVar **/
#define RADIAN			0x64
#define DEGREE			0x65
#define NORMAL			0x66
#define SCI				0x67
#define ENG				0x68
#define FLOAT			0x69
#define TEST_EQUAL		0x6A
#define TEST_LESSTHAN	0x6B
#define TEST_HIGHTHAN	0x6C
#define TEST_LOREQU		0x6D
#define TEST_GOREQU		0x6E
#define TEST_NOTEQUAL	0x6F
#define ADD				0x70
#define SUBTRACT		0x71
#define ANSWER			0x72
#define FIX				0x73
#define HORIZ			0x74
#define FULL			0x75
#define FUNC			0x76
#define PARAM			0x77
#define POLAR			0x78
#define SEQ				0x79
#define INDPNTAUTO		0x7A
#define INDPNTASK		0x7B
#define DEPENDAUTO		0x7C
#define DEPENDASK		0x7D
/** 7E VARIABLES, ie. graph manipulation **/
#define BOX				0x7F
#define DIVIDE			0x80
#define DOT				0x81
#define MULTIPLY		0x82
#define DIVIDE_SLASH	0x83
#define TRACE			0x84
#define CLRDRAW			0x85
#define ZSTANDARD		0x86
#define ZTRIG			0x87
#define ZBOX			0x88
#define ZOOMIN			0x89
#define ZOOMOUT			0x8A
#define ZSQUARE			0x8B
#define ZINTEGER		0x8C
#define ZPREVIOUS		0x8D
#define ZDECIMAL		0x8E
#define ZOOMSTAT		0x8F
#define ZOOMRCL			0x90
#define PRINTSCREEN		0x91
#define ZOOMSTO			0x92
#define TEXTFUNC		0x93
#define NPR				0x94
#define NCR				0x95
#define FNON			0x96
#define FNOFF			0x97
#define STOREPIC		0x98
#define RECALLPIC		0x99
#define STOREGDB		0x9A
#define RECALLGDB		0x9B
#define LINE			0x9C
#define VERTICAL		0x9D
#define PTON			0x9E
#define PTOFF			0x9F
#define PTCHANGE		0xA0
#define PXLON			0xA1
#define PXLOFF			0xA2
#define PXLCHANGE		0xA3
#define SHADE			0xA4
#define CIRCLE			0xA5
#define HORIZONTAL		0xA6
#define TANGENT			0xA7
#define DRAWINV			0xA8
#define DRAWF			0xA9
#define RAND			0xAB
#define PI				0xAC
#define GETKEY			0xAD
#define APOSTROPHE		0xAE
#define QUESTIONMARK	0xAF
/** SysVar **/
#define NEGATIVE		0xB0
#define CONV_INT		0xB1
#define ABS				0xB2
#define DETERMINANT		0xB3
#define IDENTITY		0xB4
#define DIM				0xB5
#define SUM				0xB6
#define PROD			0xB7
#define NOT				0xB8
#define IPART			0xB9
#define FPART			0xBA
/** BB tokens **/
#define SQR_ROOT		0xBC
#define CUBE_ROOT		0xBD
#define NATLOG			0xBE
#define ETOPOWER		0xBF
#define LOGARITHM		0xC0
#define POWER10			0xC1
#define SINE			0xC2
#define INVSIN			0xC3
#define COSINE			0xC4
#define INVCOSINE		0xC5
#define TANGENT_TRIG	0xC6
#define INVTANGENT		0xC7
#define HYP_SINE		0xC8
#define HYP_ISINE		0xC9
#define HYP_COSINE		0xCA
#define HYP_ICOSINE		0xCB
#define HYP_TANGENT		0xCC
#define HYP_ITANGENT	0xCD
#define LOGIC_IF		0xCE
#define LOGIC_THEN		0xCF
#define LOGIC_ELSE		0xD0
#define CTL_WHILE		0xD1
#define CTL_REPEAT		0xD2
#define CTL_FOR			0xD3
#define CTL_END			0xD4
#define CTL_RETURN		0xD5
#define LABEL			0xD6
#define CTL_GOTO		0xD7
#define CTL_PAUSE		0xD8
#define CTL_STOP		0xD9
#define INCSKIPIFHIGH	0xDA
#define DECSKIPIFLOW	0xDB
#define INPUT			0xDC
#define PROMPT			0xDD
#define DISP			0xDE
#define DISPGRAPH		0xDF
#define OUTPUT			0xE0
#define CLRHOME			0xE1
#define FILL			0xE2
#define SORTA			0xE3
#define SORTD			0xE4
#define DISPTABLE		0xE5
#define MENU			0xE6
#define SEND			0xE7
#define GET				0xE8
#define PLOTSON			0xE9
#define PLOTSOFF		0xEA
#define LIST			0xEB
#define PLOT1			0xEC
#define PLOT2			0xED
#define PLOT3			0xEE
#define POWEROF			0xF0
#define XTHROOT			0xF1
#define VARSTATS_1		0xF2
#define VARSTATS_2		0xF3
#define LINREG1			0xF4
#define EXPREG			0xF5
#define LNREG			0xF6
#define PWRREG			0xF7
#define MEDMED			0xF8
#define QUADREG			0xF9
#define CLRLIST			0xFA
#define CLRTABLE		0xFB
#define HISTOGRAM		0xFC
#define XYLINE			0xFD
#define SCATTER			0xFE
#define LINREG2			0xFF

// SYSTEM VARIABLES //////////////
/** MI: revision 1, byte order was wrong **/
// matrices
#define MAT_A			0x005C
#define MAT_B			0x015C
#define MAT_C			0x025C
#define MAT_D			0x035C
#define MAT_E			0x045C
#define MAT_F			0x055C
#define MAT_G			0x065C
#define MAT_H			0x075C
#define MAT_I			0x085C
#define MAT_J			0x095C
// lists
#define L1				0x005D
#define L2				0x015D
#define L3				0x025D
#define L4				0x035D
#define L5				0x045D
#define L6				0x055D
#define L7				0x065D
#define L8				0x075D
#define L9				0x085D
#define L0				0x095D
// graph (function)
#define Y1				0x105E
#define Y2				0x115E
#define Y3				0x125E
#define Y4				0x135E
#define Y5				0x145E
#define Y6				0x155E
#define Y7				0x165E
#define Y8				0x175E
#define Y9				0x185E
#define Y0				0x195E
// graph (parametric)
#define X1T				0x205E
#define Y1T				0x215E
#define X2T				0x225E
#define Y2T				0x235E
#define X3T				0x245E
#define Y3T				0x255E
#define X4T				0x265E
#define Y4T				0x275E
#define X5T				0x285E
#define Y5T				0x295E
#define X6T				0x2A5E
#define Y6T				0x2B5E
// graph (polar)
#define R1				0x405E
#define R2				0x415E
#define R3				0x425E
#define R4				0x435E
#define R5				0x445E
#define R6				0x455E
// pictures
#define PIC1			0x0060
#define PIC2			0x0160
#define PIC3			0x0260
#define PIC4			0x0360
#define PIC5			0x0460
#define PIC6			0x0560
#define PIC7			0x0660
#define PIC8			0x0760
#define PIC9			0x0860
#define PIC0			0x0960
// graph databases
#define GDB1			0x0061
#define GDB2			0x0161
#define GDB3			0x0261
#define GDB4			0x0361
#define GDB5			0x0461
#define GDB6			0x0561
#define GDB7			0x0661
#define GDB8			0x0761
#define GDB9			0x0861
#define GDB0			0x0961
// Stat data
// TODO: fill in the stat data and add it to the CalcVars array
// strings
#define STR1			0x00AA
#define STR2			0x01AA
#define STR3			0x02AA
#define STR4			0x03AA
#define STR5			0x04AA
#define STR6			0x05AA
#define STR7			0x06AA
#define STR8			0x07AA
#define STR9			0x08AA
#define STR0			0x09AA

// 7E VARIABLES //////////////////
// append 7E to all
#define SEQUENTIAL_7E	0x007E
#define SIMUL			0x017E
#define POLARGC			0x027E
#define RECTGC			0x037E
#define COORDON			0x047E
#define COORDOFF		0x057E
#define CONNECTED		0x067E
#define DOT_7E			0x077E
#define AXESON			0x087E
#define AXESOFF			0x097E
#define GRIDON			0x0A7E
#define GRIDOFF			0x0B7E
#define LABELON			0x0C7E
#define LABELOFF		0x0D7E
#define WEB				0x0E7E
#define TIME			0x0F7E
#define UVAXES			0x107E
#define VWAXES			0x117E
#define UWAXES			0x127E

// BB VARIABLES //////////////////
#define NPV				0x00BB
#define IRR				0x01BB
#define BAL				0x02BB
#define SUMPRN			0x03BB
#define SUMINT			0x04BB
#define TONOM			0x05BB
#define TOEFF			0x06BB
#define DBD				0x07BB
#define LCM				0x08BB
#define GCD				0x09BB
#define RANDINT			0x0ABB
#define RANDBIN			0x0BBB
#define SUB				0x0CBB
#define STDDEV			0x0DBB
#define VARIANCE		0x0EBB
#define INSTRING		0x0FBB
#define NORMALCDF		0x10BB
#define INVNORM			0x11BB
#define TCDF			0x12BB
#define XSQUCDF			0x13BB
#define FCDF			0x14BB
#define BINOMPDF		0x15BB
#define BINOMCDF		0x16BB
#define POISSONPDF		0x17BB
#define POISSONCDF		0x18BB
#define GEOMETPDF		0x19BB
#define GEOMETCDF		0x1ABB
#define NORMALPDF		0x1BBB
#define TPDF			0x1CBB
#define XSQUPDF			0x1DBB
#define FPDF			0x1EBB
#define RANDNORM		0x1FBB
#define TVM_PMT			0x20BB
#define TVM_I_PERCENT	0x21BB
#define TVM_PV			0x22BB
#define TVM_N			0x23BB
#define TVM_FV			0x24BB
#define CONJ			0x25BB
#define REAL			0x26BB
#define IMAG			0x27BB
#define ANGLE			0x28BB
#define CUMSUM			0x29BB
#define EXPR			0x2ABB
#define LENGTH			0x2BBB
#define DELTA_LIST		0x2CBB
#define REF				0x2DBB
#define RREF			0x2EBB
#define TORECT			0x2FBB
#define TOPOLAR			0x30BB
#define VAR_E			0x31BB
#define SINREG			0x32BB
#define LOGISTIC		0x33BB
#define LINREGTTEST		0x34BB
#define SHADENORM		0x35BB
#define SHADE_T			0x36BB
#define SHADEXSQU		0x37BB
#define SHADEF			0x38BB
#define MATRTOLIST		0x39BB
#define LISTTOMATR		0x3ABB
#define ZTEST			0x3BBB
#define TTEST			0x3CBB
#define TWO_SAMPZTEST	0x3DBB
#define ONE_PROPZTEST	0x3EBB
#define TWO_PROPZTEST	0x3FBB
#define XSQUTEST		0x40BB
#define ZINTERVAL		0x41BB
#define TWO_SAMPZINT	0x42BB
#define ONE_PROPZINT	0x43BB
#define TWO_PROPZINT	0x44BB
#define GRAPHSTYLE		0x45BB
#define TWO_SAMPTTEST	0x46BB
#define TWO_SAMPFTEST	0x47BB
#define TINTERVAL		0x48BB
#define TWO_SAMPTINT	0x49BB
#define SETUPEDITOR		0x4ABB
#define PMT_END			0x4BBB
#define PMT_BGN			0x4CBB
#define REAL_BB			0x4DBB
#define REPOWTHETAI		0x4EBB
#define APLUSBI			0x4FBB
#define EXPRON			0x50BB
#define EXPROFF			0x51BB
#define CLRALLLISTS		0x52BB
#define GETCALC			0x53BB
#define DELVAR			0x54BB
#define EQUTOSTRING		0x55BB
#define STRINGTOEQU		0x56BB
#define CLEARENTRIES	0x57BB
#define SELECT			0x58BB
#define ANOVA			0x59BB
#define MODBOXPLOT		0x5ABB
#define NORMPROBPLOT	0x5BBB
